﻿using Microsoft.Win32;
using System;
using System.Windows;
using System.Windows.Media.Imaging;
using ConPDS.Net.Data;
using System.Runtime.InteropServices;

namespace ConPDS.Net
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void btnLoad_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog op = new OpenFileDialog();
            op.Title = "Select a picture";
            op.Filter = "All supported graphics|*.jpg;*.jpeg;*.png|" +
              "JPEG (*.jpg;*.jpeg)|*.jpg;*.jpeg|" +
              "Portable Network Graphic (*.png)|*.png";
            if (op.ShowDialog() == true)
            {
                imgPhoto.Source = new BitmapImage(new Uri(op.FileName));
                System.Drawing.Image img = System.Drawing.Image.FromFile(op.FileName);

                BindUIByRecogFromBMP(img);
                RecogFromBMPToJSON(img);
            }
        }

        private void BindUIByRecogFromBMP(System.Drawing.Image img)
        {
            try
            {  
                ContainerCodeData recogStructure = ConPDS.Net.Proxy.RecogFromBMP(img);

                if (recogStructure.Result == null)
                {
                    textStructValue.Text = "<text not Recognized>";
                }
                else
                {
                    textStructValue.Text = recogStructure.Result;
                }
            }
            catch (ExternalException extExc)
            {
                textStructValue.Text = extExc.Message;
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message, "Error:");
            }
        }

        private void RecogFromBMPToJSON(System.Drawing.Image img)
        {
            try
            {
                string jsonData = ConPDS.Net.Proxy.RecogFromBMPToJSON(img);

                if (!string.IsNullOrEmpty(jsonData))
                {
                    jsonBodyValue.Text = jsonData;
                    dynamic data = Newtonsoft.Json.JsonConvert.DeserializeObject(jsonData);
                    textJsonValue.Text = data.result;
                }
            }
            catch (ExternalException extExc)
            {
                textJsonValue.Text = extExc.Message;
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message, "Error:");
            }
        }
    }
}
